//#define _DEBUG
// Atmega 168 und 328 können nur bis zu 12 Servos unterstützen (Anzahl der verfügbaren Timer)
//FrSky SBus-Servo-Adapter - das Projekt unterliegt der GHNU-OpenSource-Lezens und er CERN-Openhardware-lizens

#include <avr/io.h>
#include <avr/wdt.h>
#include <FUTABA_SBUS.h>
#include <EEPROM.h>
#include <Servo.h> 

#if defined(__AVR_ATmega168__) || defined(__AVR_ATmega328P__) || defined(__AVR_ATmega32U4__)
  #define MAX_SERVO 12
#else
  #define MAX_SERVO 16
#endif 

#define S_CH0 A4
#define S_CH1 A5
#define S_CH2 9
#define S_CH3 8
#define S_CH4 7
#define S_CH5 6
#define S_CH6 5
#define S_CH7 4

#define S_CH8 A3
#define S_CH9 A2
#define S_CH10 A1
#define S_CH11 A0
#define S_CH12 13
#define S_CH13 12
#define S_CH14 11
#define S_CH15 10
  
#define PWM_TRIGGER_HIGH 1550
#define PWM_TRIGGER_LOW 1450

#define LED 13




FUTABA_SBUS sBus;
Servo FrSkyServo[MAX_SERVO];
byte max_servo=12,pin[16]={S_CH0,S_CH1,S_CH2,S_CH3,S_CH4,S_CH5,S_CH6,S_CH7,S_CH8,S_CH9,S_CH10,S_CH11,S_CH12,S_CH13,S_CH14,S_CH15}; 
//------------------------------------------------------------
void setup()
{
  char max_servo_temp=0;
   pinMode(pin[15],INPUT_PULLUP);
 //   Serial.begin(115200);
 //  Serial.print(digitalRead(pin[15]),DEC);
  pinMode(LED,OUTPUT);
  digitalWrite(LED,LOW);
  if(!digitalRead(pin[15]))
  {
    //Serial.begin(115200);
    //Serial.print("Max. Servo:");
    
    while(!digitalRead(pin[15]))
    {
        for(byte i=0;i<2*max_servo_temp;i++)
        {
          digitalWrite(LED,digitalRead(LED)^1);
          delay(250);
        }
        delay(1000);
       max_servo_temp++;
       if(max_servo_temp>=MAX_SERVO)max_servo_temp=0;
    }
    max_servo_temp--;
    //Serial.print(max_servo_temp,HEX);
    EEPROM.write(0,max_servo_temp);
    max_servo=EEPROM.read(0);
    for(byte i=0;i<2*max_servo;i++)
    {
       digitalWrite(LED,digitalRead(LED)^1);
       delay(250);
    }
    if(max_servo > MAX_SERVO) max_servo = MAX_SERVO;
    
   }  

   max_servo=EEPROM.read(0);
   if(max_servo > MAX_SERVO) max_servo = MAX_SERVO;
   wdt_enable(WDTO_2S);
 

  sBus.begin(952,2048);

   for(byte i=0;i<max_servo;i++)
   {
      if(max_servo == i)
        pinMode(pin[i],OUTPUT);
      else
        FrSkyServo[i].attach(pin[i]);
   } 
   wdt_reset();
}
//------------------------------------------------------
void loop()
{
  wdt_reset();
  sBus.FeedLine();
  if (sBus.toChannels == 1)
  {
    sBus.UpdateServos();
    sBus.UpdateChannels();
    sBus.toChannels = 0;
    for(byte i=0; i<16 ;i++)
    {  
      if(i<MAX_SERVO)     
        FrSkyServo[i].writeMicroseconds(sBus.channels[i]);
      else 
      {
        if(sBus.channels[i] >= PWM_TRIGGER_HIGH) digitalWrite(pin[i],HIGH);
        else if(sBus.channels[i] <= PWM_TRIGGER_LOW)digitalWrite(pin[i],LOW);
      }
    }
  }
}
